=== debian/changelog ===
cen64 (0.3+git20150909-1) unstable; urgency=medium

  * New upstream git snapshot.
  * debian/control:
    - Drop unsupported architectures for cen64 binary package
      (Closes: #793342, #793343).

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Wed, 09 Sep 2015 11:21:18 +0200

cen64 (0.3+git20150705-1) unstable; urgency=medium

  * New upstream git snapshot.
  * debian/control:
    - Add libopenal-dev to Build-Depends.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 23 Jul 2015 11:18:07 +0200

cen64 (0.3+git20150128-1) unstable; urgency=low

  * Initial release (Closes: #782661).

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Wed, 15 Apr 2015 22:14:36 +0200
