## cen64 0.3+git20150705

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
-# CEN64: Cycle-Accurate Nintendo 64 Simulator.
-# Copyright (C) 2014, Tyler J. Stachecki.
+# CEN64: Cycle-Accurate Nintendo 64 Emulator.
+# Copyright (C) 2015, Tyler J. Stachecki.
 #
 # This file is subject to the terms and conditions defined in
 # 'LICENSE', which is part of this source code package.
@@ -18,6 +18,7 @@
   find_package(OpenGL REQUIRED)
 endif(APPLE)
 
+find_package(OpenAL REQUIRED)
 find_package(Threads REQUIRED)
 
 # If using GCC, configure it accordingly.
@@ -53,16 +54,17 @@
       set(CMAKE_ASM-ATT_FLAGS "${CMAKE_ASM-ATT_FLAGS} -march=avx --defsym __AVX__=1")
     endif ()
 
-#    if (${GCC_MACHINE} MATCHES "i.86.*" OR ${GCC_MACHINE} MATCHES "x86.*")
-#      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffixed-xmm8 -ffixed-xmm9 -ffixed-xmm10")
-#      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffixed-xmm11 -ffixed-xmm12 -ffixed-xmm13 -ffixed-xmm14 -ffixed-xmm15")
-#    endif (${GCC_MACHINE} MATCHES "i.86.*" OR ${GCC_MACHINE} MATCHES "x86.*")
+    if (${GCC_MACHINE} MATCHES "i.86.*" OR ${GCC_MACHINE} MATCHES "x86.*")
+      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffixed-xmm8 -ffixed-xmm9 -ffixed-xmm10")
+      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffixed-xmm11 -ffixed-xmm12 -ffixed-xmm13 -ffixed-xmm14 -ffixed-xmm15")
+    endif (${GCC_MACHINE} MATCHES "i.86.*" OR ${GCC_MACHINE} MATCHES "x86.*")
 
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -maccumulate-outgoing-args")
 
     set(CEN64_ARCH_DIR "x86_64")
     include_directories(${PROJECT_SOURCE_DIR}/os/unix/x86_64)
 
+    set(ASM_SOURCES ${PROJECT_SOURCE_DIR}/arch/x86_64/gcc/context.s)
 #    file(GLOB ASM_SOURCES ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/gcc/*.s)
   endif (${GCC_MACHINE} MATCHES "x86.*" OR ${GCC_MACHINE} MATCHES "i.86.*")
 
@@ -228,37 +230,61 @@
 include_directories(${PROJECT_BINARY_DIR})
 include_directories(${PROJECT_SOURCE_DIR})
 include_directories(${PROJECT_SOURCE_DIR}/arch/${CEN64_ARCH_DIR})
-
-file(GLOB AI_SOURCES ${PROJECT_SOURCE_DIR}/ai/*.c)
-file(GLOB BUS_SOURCES ${PROJECT_SOURCE_DIR}/bus/*.c)
-file(GLOB COMMON_SOURCES ${PROJECT_SOURCE_DIR}/common/*.c)
-file(GLOB DD_SOURCES ${PROJECT_SOURCE_DIR}/dd/*.c)
-file(GLOB OS_COMMON_SOURCES ${PROJECT_SOURCE_DIR}/os/*.c)
-file(GLOB PI_SOURCES ${PROJECT_SOURCE_DIR}/pi/*.c)
-file(GLOB RI_SOURCES ${PROJECT_SOURCE_DIR}/ri/*.c)
-file(GLOB SI_SOURCES ${PROJECT_SOURCE_DIR}/si/*.c)
-file(GLOB RDP_SOURCES ${PROJECT_SOURCE_DIR}/rdp/*.c)
-file(GLOB RSP_SOURCES ${PROJECT_SOURCE_DIR}/rsp/*.c)
-file(GLOB VI_SOURCES ${PROJECT_SOURCE_DIR}/vi/*.c)
-file(GLOB VR4300_SOURCES ${PROJECT_SOURCE_DIR}/vr4300/*.c)
-file(GLOB ARCH_FPU_SOURCES arch/${CEN64_ARCH_DIR}/fpu/*.c)
-file(GLOB ARCH_RSP_SOURCES arch/${CEN64_ARCH_DIR}/rsp/*.c)
-file(GLOB ARCH_TLB_SOURCES arch/${CEN64_ARCH_DIR}/tlb/*.c)
-
-#
-# Glob all the files together.
-#
-if (DEFINED UNIX)
-  if (${CMAKE_C_COMPILER_ID} MATCHES GNU OR ${CMAKE_C_COMPILER_ID} MATCHES Clang OR ${CMAKE_C_COMPILER_ID} MATCHES Intel)
-    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_POSIX_C_SOURCE=200112L -D_BSD_SOURCE")
-  endif (${CMAKE_C_COMPILER_ID} MATCHES GNU OR ${CMAKE_C_COMPILER_ID} MATCHES Clang OR ${CMAKE_C_COMPILER_ID} MATCHES Intel)
-
-  file(GLOB OS_SOURCES ${PROJECT_SOURCE_DIR}/os/unix/*.c)
-
-  if (NOT DISABLE_X11)
-    find_package(X11 REQUIRED)
-    include_directories(${X11_xf86vmode_INCLUDE_PATH})
-    set(EXTRA_OS_LIBS ${X11_X11_LIB} ${X11_Xxf86vm_LIB})
-    set(EXTRA_OS_EXE "")
-
-    file(GLOB X11_SOURCES ${PROJECT_SOURCE_DIR}/os/unix/x11/*.c)
+include_directories(${PROJECT_SOURCE_DIR}/os/common)
+include_directories(${OPENAL_INCLUDE_DIR})
+
+#
+# Create lists of files.
+#
+set(AI_SOURCES
+  ${PROJECT_SOURCE_DIR}/ai/context.c
+  ${PROJECT_SOURCE_DIR}/ai/controller.c
+)
+
+set(ARCH_X86_64_SOURCES
+  ${PROJECT_SOURCE_DIR}/arch/x86_64/gcc/context.s
+  ${PROJECT_SOURCE_DIR}/arch/x86_64/tlb/tlb.c
+  ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/vrcpsq.c
+  ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/vmov.c
+  ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/vdivh.c
+  ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/rsp.c
+  ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/vrsq.c
+)
+
+set(BUS_SOURCES
+  ${PROJECT_SOURCE_DIR}/bus/controller.c
+  ${PROJECT_SOURCE_DIR}/bus/memorymap.c
+)
+
+set(COMMON_SOURCES
+  ${PROJECT_SOURCE_DIR}/common/debug.c
+  ${PROJECT_SOURCE_DIR}/common/one_hot.c
+  ${PROJECT_SOURCE_DIR}/common/reciprocal.c
+)
+
+set(DD_SOURCES
+  ${PROJECT_SOURCE_DIR}/dd/controller.c
+)
+
+set(DEVICE_SOURCES
+  ${PROJECT_SOURCE_DIR}/cen64.c
+  ${PROJECT_SOURCE_DIR}/device/device.c
+  ${PROJECT_SOURCE_DIR}/device/netapi.c
+  ${PROJECT_SOURCE_DIR}/device/options.c
+)
+
+set(OS_SOURCES
+  ${PROJECT_SOURCE_DIR}/os/common/gl_hints.c
+  ${PROJECT_SOURCE_DIR}/os/common/input.c
+)
+
+set(OS_POSIX_SOURCES
+  ${PROJECT_SOURCE_DIR}/os/posix/alloc.c
+  ${PROJECT_SOURCE_DIR}/os/posix/main.c
+  ${PROJECT_SOURCE_DIR}/os/posix/rom_file.c
+  ${PROJECT_SOURCE_DIR}/os/posix/timer.c
+)
+
+set(OS_WINAPI_SOURCES
+  ${PROJECT_SOURCE_DIR}/os/winapi/alloc.c
+  ${PROJECT_SOURCE_DIR}/os/winapi/gl_config.c
