=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: otherosfs
 Priority: optional
 Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
-Build-Depends: debhelper (>= 9), cmake, libgl1-mesa-dev
+Build-Depends: debhelper (>= 9), cmake, libgl1-mesa-dev, libopenal-dev
 Standards-Version: 3.9.6
 Homepage: http://www.cen64.com/
 Vcs-Git: git://github.com/glaubitz/cen64-debian.git
