=== debian/watch ===
version=3
https://github.com/tj90241/cen64/tags .*/v?(\d.*)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))
