## cen64 0.3+git20160403

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 #
 
 cmake_minimum_required(VERSION 2.8)
-project(cen64)
+project(cen64 C)
 
 if(APPLE)
   set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules" ${CMAKE_MODULE_PATH})
@@ -36,6 +36,10 @@
 
     set(CEN64_ARCH_SUPPORT "SSE2" CACHE STRING "Architectural extension(s) to use")
     set_property(CACHE CEN64_ARCH_SUPPORT PROPERTY STRINGS SSE2 SSE3 SSSE3 SSE4.1 AVX)
+
+    if (WIN32)
+      set(CMAKE_ASM-ATT_FLAGS "${CMAKE_ASM-ATT_FLAGS} -defsym __MINGW__=1")
+    endif (WIN32)
 
     if (${CEN64_ARCH_SUPPORT} MATCHES "SSE2")
       set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse2")
@@ -64,7 +68,9 @@
     set(CEN64_ARCH_DIR "x86_64")
     include_directories(${PROJECT_SOURCE_DIR}/os/unix/x86_64)
 
-    set(ASM_SOURCES ${PROJECT_SOURCE_DIR}/arch/x86_64/gcc/context.s)
+    if (NOT APPLE)
+      set(ASM_SOURCES ${PROJECT_SOURCE_DIR}/arch/x86_64/gcc/context.s)
+    endif ()
 #    file(GLOB ASM_SOURCES ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/gcc/*.s)
   endif (${GCC_MACHINE} MATCHES "x86.*" OR ${GCC_MACHINE} MATCHES "i.86.*")
 
@@ -125,6 +131,8 @@
   string(REGEX MATCH "([a-zA-Z0-9])+" CLANG_MACHINE ${CLANG_MACHINE})
 
   if (${CLANG_MACHINE} MATCHES "x86.*" OR ${CLANG_MACHINE} MATCHES "i.86.*")
+    enable_language(ASM-ATT)
+
     set(CEN64_ARCH_SUPPORT "SSE2" CACHE STRING "Architectural extension(s) to use")
     set_property(CACHE CEN64_ARCH_SUPPORT PROPERTY STRINGS SSE2 SSE3 SSSE3 SSE4.1 AVX Native)
 
@@ -144,6 +152,11 @@
 
     set(CEN64_ARCH_DIR "x86_64")
     include_directories(${PROJECT_SOURCE_DIR}/os/unix/x86_64)
+
+    if (NOT APPLE)
+      set(ASM_SOURCES ${PROJECT_SOURCE_DIR}/arch/x86_64/gcc/context.s)
+    endif ()
+#    file(GLOB ASM_SOURCES ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/gcc/*.s)
   endif (${CLANG_MACHINE} MATCHES "x86.*" OR ${CLANG_MACHINE} MATCHES "i.86.*")
 
   if (${CLANG_MACHINE} STREQUAL "arm")
@@ -154,7 +167,11 @@
   endif (${CLANG_MACHINE} STREQUAL "arm")
 
   # Set architecture-independent flags.
-  set(CMAKE_C_FLAGS_DEBUG "-ggdb3 -g3 -O0 -fsanitize=undefined")
+  if (APPLE)
+    set(CMAKE_C_FLAGS_DEBUG "-ggdb3 -g3 -O0")
+  else ()
+    set(CMAKE_C_FLAGS_DEBUG "-ggdb3 -g3 -O0 -fsanitize=undefined")
+  endif ()
   set(CMAKE_C_FLAGS_MINSIZEREL "-Os -DNDEBUG")
   set(CMAKE_C_FLAGS_RELEASE "-O3 -DNDEBUG")
   set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O3 -DNDEBUG -ggdb3 -g3")
@@ -242,7 +259,6 @@
 )
 
 set(ARCH_X86_64_SOURCES
-  ${PROJECT_SOURCE_DIR}/arch/x86_64/gcc/context.s
   ${PROJECT_SOURCE_DIR}/arch/x86_64/tlb/tlb.c
   ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/vrcpsq.c
   ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/vmov.c
@@ -251,6 +267,11 @@
   ${PROJECT_SOURCE_DIR}/arch/x86_64/rsp/vrsq.c
 )
 
+if (NOT APPLE)
+  list(APPEND ARCH_X86_64_SOURCES
+    ${PROJECT_SOURCE_DIR}/arch/x86_64/gcc/context.s)
+endif ()
+
 set(BUS_SOURCES
   ${PROJECT_SOURCE_DIR}/bus/controller.c
   ${PROJECT_SOURCE_DIR}/bus/memorymap.c
@@ -268,23 +289,3 @@
 
 set(DEVICE_SOURCES
   ${PROJECT_SOURCE_DIR}/cen64.c
-  ${PROJECT_SOURCE_DIR}/device/device.c
-  ${PROJECT_SOURCE_DIR}/device/netapi.c
-  ${PROJECT_SOURCE_DIR}/device/options.c
-)
-
-set(OS_SOURCES
-  ${PROJECT_SOURCE_DIR}/os/common/gl_hints.c
-  ${PROJECT_SOURCE_DIR}/os/common/input.c
-)
-
-set(OS_POSIX_SOURCES
-  ${PROJECT_SOURCE_DIR}/os/posix/alloc.c
-  ${PROJECT_SOURCE_DIR}/os/posix/main.c
-  ${PROJECT_SOURCE_DIR}/os/posix/rom_file.c
-  ${PROJECT_SOURCE_DIR}/os/posix/timer.c
-)
-
-set(OS_WINAPI_SOURCES
-  ${PROJECT_SOURCE_DIR}/os/winapi/alloc.c
-  ${PROJECT_SOURCE_DIR}/os/winapi/gl_config.c
