=== debian/changelog ===
cen64 (0.3+git20160403-1) unstable; urgency=medium

  * New upstream git snapshot.
  * Update years in debian/copyright.
  * Update standards version to 3.9.8 in debian/control.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 15 May 2016 19:23:17 +0200
