=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
 Build-Depends: debhelper (>= 9), cmake, libgl1-mesa-dev, libopenal-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://www.cen64.com/
 Vcs-Git: git://github.com/glaubitz/cen64-debian.git
 Vcs-Browser: https://github.com/glaubitz/cen64-debian/
