=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: cen64
 Section: otherosfs
 Priority: optional
-Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
-Build-Depends: debhelper (>= 9), cmake, libgl1-mesa-dev, libopenal-dev
-Standards-Version: 3.9.8
-Homepage: http://www.cen64.com/
-Vcs-Git: git://github.com/glaubitz/cen64-debian.git
-Vcs-Browser: https://github.com/glaubitz/cen64-debian/
+Maintainer: Dan Hasting <maintainer@hasting.email>
+Build-Depends: debhelper (>= 11), cmake, libgl1-mesa-dev, libopenal-dev
+Standards-Version: 4.1.3
+Homepage: https://www.cen64.com/
+Vcs-Git: https://github.com/dh4/cen64-debian.git
+Vcs-Browser: https://github.com/dh4/cen64-debian/
 
 Package: cen64
 Architecture: amd64
